////////////////////////////////////////////////////////////////////////////////
//! \file
//!
//! \author	Mauro Fiorentini
//!
//! \date	19/09/2021
//!
//! \par	Function:
//!	Contains the declaration of the GraphicSpace::Exception abstract class.
//!
////////////////////////////////////////////////////////////////////////////////

# if	!defined EXCEPTION_H

# define	EXCEPTION_H

# include	<stdio.h>

namespace	GraphicSpace
{

////////////////////////////////////////////////////////////////////////////////
//! \class	Exception
//!	The Exception abstract class is the the parent class of all exceptions
//!	in the GraphicSpace.
//!
////////////////////////////////////////////////////////////////////////////////

class	Exception
	{
	private:

//! \property	FatalErrorMessage;
//!	Message written when a fatal error occurs.
		static	const	char*	const	FatalErrorMessage;

	protected:

						Exception(void) noexcept;

		[[noreturn]]	static	void	FatalError(void) noexcept;

				virtual		~Exception(void) noexcept =
							default;

	public:

				virtual	void	Write(FILE* OutputFile) const
							noexcept PURE_VIRTUAL;

	};

}

# endif
