////////////////////////////////////////////////////////////////////////////////
//! \file
//!
//! \author	Mauro Fiorentini
//!
//! \date	19/09/2021
//!
//! \par	Function:
//!	Contains the definitions of non inline functions of the
//!	GraphicSpace::Exception class.
//!
////////////////////////////////////////////////////////////////////////////////

# include	"Graphic.h"
# include	"Exception.h"

# include	<stdlib.h>

namespace	GraphicSpace
{

const	char*	const	Exception::FatalErrorMessage =
				"Fatal error, terminating\n";

////////////////////////////////////////////////////////////////////////////////
//! \par	Description:
//!	Constructor.
//!
//! \throw	None.
//!
//! \returns	Not applicable
//!
////////////////////////////////////////////////////////////////////////////////

Exception::Exception(void) noexcept
	{
	}

////////////////////////////////////////////////////////////////////////////////
//! \par	Description:
//!	Write an error message and terminate the execution.
//!
//! \throw	None.
//!
//! \returns	None.
//!
//! \note
//!	The function does not return.
//!
////////////////////////////////////////////////////////////////////////////////

[[noreturn]]	void	Exception::FatalError(void) noexcept
	{
	IgnoreValue(fprintf(stderr, FatalErrorMessage));
	exit(EXIT_FAILURE);
	}

}
